#ifdef __APPLE__
#define printf _printf
#define scanf _scanf
#define main _main
#endif

	.globl main
main:
	pushl %ebp
	movl %esp, %ebp
	// Sauvegarde du registre non-scratch par
	// l'appelé
	pushl %ebx
	// On fait de la place pour :
	// 2 arguments du printf
	// 1 sauvegarde de registres
	subl $(8+4), %esp
	andl $-16, %esp

	movl $chaine, %ecx
	
	// On n'utilise que %bl, mais on remplit
	// le reste de %ebx avec des 0.
	movl $0, %ebx
while:
	cmpb $0, (%ecx)
	je fin_while
	movb (%ecx), %bl
	// On empile les arguments de printf
	movl $fmt, (%esp)
	movl %ebx, 4(%esp)
	// Sauvegarde de %ecx
	movl %ecx, 8(%esp)
	call printf
	// Restauration de %ecx
	movl 8(%esp), %ecx
	incl %ecx // équivalent à addl $1, %ecx
	jmp while

fin_while:
	// Restauration de registres non-scratch.
	movl -4(%ebp), %ebx
	leave
	ret
.data
chaine: .asciz "Hello\n"
fmt:	.asciz "%c"
